#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include "ttm_user.h"

int ttm_get_peer(int sockfd, struct ttm_peer *peer, int *len)
{
    if (*len != sizeof(struct ttm_peer))
        return -EINVAL;
    
    return getsockopt(sockfd, IPPROTO_IP, TTM_SO_GET_PEER, peer, len);
}
