#ifndef TTM_H_INCLUDE
#define TTM_H_INCLUDE

#include <linux/types.h>

struct ttm_peer {
    __u16     af;
    __be16  port;
    union {
        __u32       all[4];
        __be32      ip;
        __be32      ip6[4];
        struct in_addr  in;
        struct in6_addr in6;
    };
};

#define TTM_BASE_CTL		(64+1024+64+64+64+64)	/* base */
#define TTM_SO_GET_PEER		(TTM_BASE_CTL+1)

#endif
