# SOL_IP == 0
# TTM_SO_GET_PEER == 1345

# struct ttm_data_v6 {
#     __u8  opcode;
#     __u8  opsize;
#     __u16 port;
#     __u8  ipv6[16];
# }__attribute__((__packed__));

from socket import *  
import struct
port = input('input listen port: ')
host = '0.0.0.0'
  
s = socket(AF_INET, SOCK_STREAM)  
s.bind((host, port))
s.listen(10)
print '...waiting for message..'  
while True:
    ss, addr = s.accept()
    # 4to4: cip&cport here
    # 6to4: bip&bport here
    print 'get client info:', addr
    print 'getpeername:', ss.getpeername()
    str = ss.getsockopt(0, 1345, 20)
    # parse msg in obj_p format
    obj_p = struct.Struct('!bbH4s12s')
    data = obj_p.unpack(str)
    print data
    print 'port:', data[2]

    # 4to4: cip&cport here
    # 6to4: cip&cport here
    if(data[0] == 2):
        print 'ipv4:', inet_ntop(data[0], data[3]) # 2 is AF_INET
    else:
        print 'ipv6:', inet_ntop(data[0], data[3]+data[4]) # 10 is AF_INET6

    while True:
        ss.recv(1000)
        ss.send('server')
    ss.close()
s.close()

